/*** CGR.C ***/

#include "graficos.c"
#include "escondid.c"

void main(int argc, char **argv) {

  FILE *arq;
  long quant, i;
  int opcao, cor_f1, cor_f2, cor_int1, cor_int2, cor_int3,
      cor_int4, padrao1, padrao2, j, k = 0;
  char ch, NomeArquivo[80];
  t_regiao re;
  float xmin, xmax, ymin, ymax, zmin, zmax, smax, s1, s2, s3, s4, s5, s6,
	s7, s8;

  if (argc == 1) {
    printf("\n====================================================="
	   "==============");
    printf("\nCGR - Constroi grafico a partir de dados dos arquivos"
	   " *.DAT e *.CFG");

    printf("\n\nForma de usar: CGR arquivo1 [arquivo2] [...]");
    printf("\n====================================================="
	   "==============\n\n");
    return;
  }

  printf("\n\nESC: encerra o programa");
  printf("\nF1: muda a cor 1 da frente");
  printf("\nF2: muda a cor 2 da frente");
  printf("\nF3: muda a cor 1 de tras");
  printf("\nF4: muda a cor 2 de tras");
  printf("\nF5: muda a cor da fronteira da frente");
  printf("\nF6: muda a cor da fronteira de tras");
  printf("\nF7: muda o padrao de bits das cores da frente");
  printf("\nF8: muda o padrao de bits das cores de tras");
  printf("\nF9: muda a cor da envolvente\n");
  printf("\n\nPressione qualquer tecla para continuar");
  getch();

  IniciaModoGrafico();

  for (j = 2; j <= argc; j++) {
    strcpy(NomeArquivo, argv[j - 1]);

    LeConfiguracaoDoGrafico(NomeArquivo, &cor_f1, &cor_f2, &cor_int1, &cor_int2,
       &cor_int3, &cor_int4, &padrao1, &padrao2, &opcao, &xmin, &xmax, &ymin,
       &ymax, &zmax, &zmin, &smax, &s1, &s2, &s3, &s4, &s5, &s6, &s7, &s8);

    while(NomeArquivo[k] != '\0' && NomeArquivo[k] != '.') k++;
    NomeArquivo[k] = '\0';
    strcat(NomeArquivo, ".DAT");
    if ((arq = fopen(NomeArquivo, "rb")) == NULL) return;
    quant = QuantasRegioes(NomeArquivo);

    do {
      if (opcao >= 0) {
	ArestaDoCubo(xmin, ymin, zmin, xmax, ymin, zmin, opcao);
	ArestaDoCubo(xmin, ymin, zmin, xmin, ymax, zmin, opcao);
	ArestaDoCubo(xmax, ymax, zmin, xmax, ymin, zmin, opcao);
	ArestaDoCubo(xmax, ymax, zmin, xmin, ymax, zmin, opcao);

	ArestaDoCubo(xmin, ymin, zmax, xmax, ymin, zmax, opcao);
	ArestaDoCubo(xmin, ymin, zmax, xmin, ymax, zmax, opcao);
	ArestaDoCubo(xmax, ymax, zmax, xmax, ymin, zmax, opcao);
	ArestaDoCubo(xmax, ymax, zmax, xmin, ymax, zmax, opcao);

	ArestaDoCubo(xmin, ymin, zmin, xmin, ymin, zmax, opcao);
	ArestaDoCubo(xmax, ymin, zmin, xmax, ymin, zmax, opcao);
	ArestaDoCubo(xmin, ymax, zmin, xmin, ymax, zmax, opcao);
	ArestaDoCubo(xmax, ymax, zmin, xmax, ymax, zmax, opcao);
      }

      for (i = quant - 1; i >= 0; i--) {
	LeRegiao(arq, i, &re);
	  if (re.cosN >= 0)
	    Pintar(re.xq1, re.yq1, re.xq2, re.yq2, re.xq3, re.yq3,
		 re.xq4, re.yq4, cor_f1, cor_int1, cor_int2, padrao1);
	  else
	    Pintar(re.xq1, re.yq1, re.xq2, re.yq2, re.xq3, re.yq3,
		 re.xq4, re.yq4, cor_f2, cor_int3, cor_int4, padrao2);
      }


      if (opcao >= 0) {
	if (smax > s1 && smax > s5)
	  ArestaDoCubo(xmin, ymin, zmin, xmax, ymin, zmin, opcao);
	if (smax > s1 && smax > s3)
	  ArestaDoCubo(xmin, ymin, zmin, xmin, ymax, zmin, opcao);
	if (smax > s7 && smax > s5)
	  ArestaDoCubo(xmax, ymax, zmin, xmax, ymin, zmin, opcao);
	if (smax > s7 && smax > s3)
	  ArestaDoCubo(xmax, ymax, zmin, xmin, ymax, zmin, opcao);
	if (smax > s2 && smax > s6)
	  ArestaDoCubo(xmin, ymin, zmax, xmax, ymin, zmax, opcao);
	if (smax > s2 && smax > s4)
	  ArestaDoCubo(xmin, ymin, zmax, xmin, ymax, zmax, opcao);
	if (smax > s8 && smax > s6)
	  ArestaDoCubo(xmax, ymax, zmax, xmax, ymin, zmax, opcao);
	if (smax > s8 && smax > s4)
	  ArestaDoCubo(xmax, ymax, zmax, xmin, ymax, zmax, opcao);
	if (smax > s1 && smax > s2)
	  ArestaDoCubo(xmin, ymin, zmin, xmin, ymin, zmax, opcao);
	if (smax > s5 && smax > s6)
	  ArestaDoCubo(xmax, ymin, zmin, xmax, ymin, zmax, opcao);
	if (smax > s3 && smax > s4)
	  ArestaDoCubo(xmin, ymax, zmin, xmin, ymax, zmax, opcao);
	if (smax > s7 && smax > s8)
	  ArestaDoCubo(xmax, ymax, zmin, xmax, ymax, zmax, opcao);
      }

      ch = getch();

      if (ch == 0) {
	 ch = getch();
	 switch (ch) {
	   case TeclaF1: cor_int1 = (cor_int1 + 1) % 16; break;
	   case TeclaF2: cor_int2 = (cor_int2 + 1) % 16; break;
	   case TeclaF3: cor_int3 = (cor_int3 + 1) % 16; break;
	   case TeclaF4: cor_int4 = (cor_int4 + 1) % 16; break;
	   case TeclaF5: cor_f1 = (cor_f1 + 1) % 16; break;
	   case TeclaF6: cor_f2 = (cor_f2 + 1) % 16; break;
	   case TeclaF7: padrao1 = (padrao1 + 1) % 256; break;
	   case TeclaF8: padrao2 = (padrao2 + 1) % 256; break;
	   case TeclaF9: opcao = (opcao + 1) % 16; break;
	 }
      }

      cleardevice();
    } while (ch != ESC);

  }
  fclose(arq);
  closegraph();
}

/*** FIM DE CGR.C ***/

